import parser._
import fun._
val p1 = ProgFun.parse(
  """
    let f = fun (x) fun (y) x + y end end in
      (f)(2)(3)
    end
  """)
eval(p1)
/*val p2 = ProgFun.parse(
  """
    let f = fun (z) fun (y) x + y end end in
      let x = 4 in (f)(2)(3) end
    end
  """)
eval(p2)*/
val p3 = ProgFun.parse(
  """
    let f = fun (y) x + y end in
      let x = 2 in
        (f)(x)
      end
    end
  """)
val s = step(p3.funs)
s(p3.corpo)
val p4 = ProgFun.parse(
  """
    fun fat(x)
      if x < 2 then
        x
      else
        x * fat(x - 1)
      end
    end
    fat(5)
  """)
eval(p4)
val p5 = ProgFun.parse(
  """
    letrec fat = fun (x)
      if x < 2 then
        x
      else
        x * (fat)(x - 1)
      end
    end in
      (fat)(5)
    end
  """)
eval(p5)
s(s(s(s(s(s(p5.corpo))))))
val p6 = ProgFun.parse(
  """
  fun cons(a, b)
    fun (c)
      if c then a else b end
    end
  end

  fun fst(p)
    (p)(true)
  end

  fun snd(p)
    (p)(false)
  end

  let p = cons(2, 3) in
    fst(p) + snd(p)
  end
  """)
eval(p6)
val p7 = ProgFun.parse(
  """
  fun cons(a, b)
    fun (c)
      if c then a else b end
    end
  end

  fun fst(p)
    (p)(true)
  end

  fun snd(p)
    (p)(false)
  end

  letrec pi = cons(
     fun (x)
       if x < 1 then
         true
       else
         (snd(pi))(x-1)
       end
     end,
     fun (x)
       if x < 1 then
         false
       else
         (fst(pi))(x-1)
       end
     end)
  in
    (fst(pi))(4)
  end
  """)
eval(p7)

val ptree =
  ProgFun.parse("""
    fun Folha(r)
      fun (f, n)
        (f)(r)
      end
    end

    fun No(e, d)
      fun (f, n)
        (n)(e, d)
      end
    end

    fun soma(arv)
      (arv)( -- arv match
        fun (r) r end,  -- case Folha(r)
        fun (e, d) soma(e) + soma(d) end -- case No(e, d)
      )
    end

    let arv = No(No(Folha(2), Folha(3)),
                 No(Folha(5), Folha(7))) in
      soma(arv)
    end

  """)
eval(ptree)

val pfat = ProgFun.parse(
"""
  let fat =
    let F2 = fun (F1)
               fun (x)
                 if x < 2 then 1
                 else x * ((F1)(F1))(x-1) end
               end
             end in (F2)(F2) end in
   (fat)(5)
  end
"""
)
eval(pfat)

val psoma = ProgFun.parse(
  """
  fun Folha(r)
    fun (f, n)
      (f)(r)
    end
  end

  fun No(e, d)
    fun (f, n)
      (n)(e, d)
    end
  end

  let soma =
    let F2 = fun (F1)
               fun (arv)
                (arv)( -- arv match
                  fun (r) r end,  -- case Folha(r)
                  fun (e, d) ((F1)(F1))(e) + ((F1)(F1))(d) end -- case No(e, d)
                )
               end
             end in (F2)(F2) end in
   (soma)(No(No(Folha(2), Folha(3)),
             No(Folha(5), Folha(7))))
  end
  """
)
eval(psoma)

val psomafix = ProgFun.parse(
  """
  fun Folha(r)
    fun (f, n)
      (f)(r)
    end
  end

  fun No(e, d)
    fun (f, n)
      (n)(e, d)
    end
  end

  fun fix1(f)
    let F2 = fun (F1)
               (f)(fun (x) ((F1)(F1))(x) end)
             end
    in (F2)(F2) end
  end

  let soma =
    fix1(fun (soma)
          fun (arv)
            (arv)( -- arv match
              fun (r) r end,  -- case Folha(r)
              fun (e, d) (soma)(e) + (soma)(d) end -- case No(e, d)
            )
          end
        end) in
   (soma)(No(No(Folha(2), Folha(3)),
             No(Folha(5), Folha(7))))
  end
  """
)
eval(psomafix)

val pref = ProgFun.parse(
  """
    let r = ref 0 in
      r := !r + 1;
      r := !r + 1;
      !r
    end
  """)
eval(pref)

val pref2 = ProgFun.parse(
"""
  let r = ref 0 in
    (r := !r + 1; !r) + (r := !r + 1; !r)
  end
""")
eval(pref2)

val preffun = ProgFun.parse(
"""
fun f(a, b, c)
  a - b - c
end

let r = ref 0 in
  f((r := !r + 1; !r),
    (r := !r + 1; !r),
    (r := !r + 1; !r))
end
""")
eval(preffun)
